
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Sale_itemsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const sale_items = await db.sale_items.create(
            {
                id: data.id || undefined,
        
        label: data.label
        ||
        null
            ,
            
        quantity: data.quantity
        ||
        null
            ,
            
        unit_price: data.unit_price
        ||
        null
            ,
            
        discount_rate: data.discount_rate
        ||
        null
            ,
            
        tax_rate: data.tax_rate
        ||
        null
            ,
            
        line_total: data.line_total
        ||
        null
            ,
            
        sort_order: data.sort_order
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await sale_items.setSale( data.sale || null, {
            transaction,
        });
        
        await sale_items.setProduct( data.product || null, {
            transaction,
        });
        

        

        

        return sale_items;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const sale_itemsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                label: item.label
            ||
            null
            ,
            
                quantity: item.quantity
            ||
            null
            ,
            
                unit_price: item.unit_price
            ||
            null
            ,
            
                discount_rate: item.discount_rate
            ||
            null
            ,
            
                tax_rate: item.tax_rate
            ||
            null
            ,
            
                line_total: item.line_total
            ||
            null
            ,
            
                sort_order: item.sort_order
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const sale_items = await db.sale_items.bulkCreate(sale_itemsData, { transaction });

        // For each item created, replace relation files
        

        return sale_items;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const sale_items = await db.sale_items.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.label !== undefined) updatePayload.label = data.label;
        
        
        if (data.quantity !== undefined) updatePayload.quantity = data.quantity;
        
        
        if (data.unit_price !== undefined) updatePayload.unit_price = data.unit_price;
        
        
        if (data.discount_rate !== undefined) updatePayload.discount_rate = data.discount_rate;
        
        
        if (data.tax_rate !== undefined) updatePayload.tax_rate = data.tax_rate;
        
        
        if (data.line_total !== undefined) updatePayload.line_total = data.line_total;
        
        
        if (data.sort_order !== undefined) updatePayload.sort_order = data.sort_order;
        
        
        updatePayload.updatedById = currentUser.id;

        await sale_items.update(updatePayload, {transaction});

        
        
        if (data.sale !== undefined) {
            await sale_items.setSale(
              
              data.sale,
              
              { transaction }
            );
        }
        
        if (data.product !== undefined) {
            await sale_items.setProduct(
              
              data.product,
              
              { transaction }
            );
        }
        

        
        

        

        return sale_items;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const sale_items = await db.sale_items.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of sale_items) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of sale_items) {
                await record.destroy({transaction});
            }
        });


        return sale_items;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const sale_items = await db.sale_items.findByPk(id, options);

        await sale_items.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await sale_items.destroy({
            transaction
        });

        return sale_items;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const sale_items = await db.sale_items.findOne(
            { where },
            { transaction },
        );

        if (!sale_items) {
            return sale_items;
        }

        const output = sale_items.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.sale = await sale_items.getSale({
            transaction
        });
        
        
        output.product = await sale_items.getProduct({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.sales,
        as: 'sale',
        
        where: filter.sale ? {
          [Op.or]: [
            { id: { [Op.in]: filter.sale.split('|').map(term => Utils.uuid(term)) } },
            {
              number: {
                [Op.or]: filter.sale.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.products,
        as: 'product',
        
        where: filter.product ? {
          [Op.or]: [
            { id: { [Op.in]: filter.product.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.product.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.label) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'sale_items',
                        'label',
                        filter.label,
                    ),
                };
            }
            

            
            

            
            if (filter.quantityRange) {
                const [start, end] = filter.quantityRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    quantity: {
                    ...where.quantity,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    quantity: {
                    ...where.quantity,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.unit_priceRange) {
                const [start, end] = filter.unit_priceRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    unit_price: {
                    ...where.unit_price,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    unit_price: {
                    ...where.unit_price,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.discount_rateRange) {
                const [start, end] = filter.discount_rateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    discount_rate: {
                    ...where.discount_rate,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    discount_rate: {
                    ...where.discount_rate,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.tax_rateRange) {
                const [start, end] = filter.tax_rateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    tax_rate: {
                    ...where.tax_rate,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    tax_rate: {
                    ...where.tax_rate,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.line_totalRange) {
                const [start, end] = filter.line_totalRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    line_total: {
                    ...where.line_total,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    line_total: {
                    ...where.line_total,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.sort_orderRange) {
                const [start, end] = filter.sort_orderRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    sort_order: {
                    ...where.sort_order,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    sort_order: {
                    ...where.sort_order,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.sale_items.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'sale_items',
                        'label',
                        query,
                    ),
                ],
            };
        }

        const records = await db.sale_items.findAll({
            attributes: [ 'id', 'label' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['label', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.label,
        }));
    }

    
};

